<template>
  <div class="transaction" :class="{ 'is-active': showSection }">
    <div class="transaction__top" @click="showSection = !showSection">
      <div class="transaction__top_left">
        <div class="transaction__top_value">
          <span>$</span>{{ transaction.amount }}
        </div>
        <div class="transaction__top_type">{{ transaction.type }}</div>
      </div>
      <div class="transaction__top_right">
        <div
          v-if="transaction.status"
          class="transaction__top_status hide-mobile"
          :class="{ color_1: transaction.status === 'CONFIRMED' }"
        >
          {{ transaction.status }}
        </div>
        <div class="transaction__top_date hide-mobile">
          <!-- {{ transaction.created_at }} -->
          {{ format(new Date(transaction.created_at), 'dd MMMM yyyy') }}
        </div>
        <div class="transaction__top_arrow"><svg-icon name="arrow" /></div>
      </div>
    </div>
    <div class="transaction__content">
      <div>
        <div v-if="transaction.client" class="transaction__info">
          <div class="transaction__info_title">Client</div>
          <div class="transaction__info_content">
            <span>{{ transaction.client }}</span>
          </div>
        </div>
        <div v-if="transaction.to" class="transaction__info">
          <div class="transaction__info_title">TO</div>
          <div class="transaction__info_content">
            {{ transaction.to }}
          </div>
        </div>
        <div class="transaction__info">
          <div class="transaction__info_title">Amount</div>
          <div class="transaction__info_content">
            {{ transaction.amount }}$
          </div>
        </div>
        <div v-if="transaction.rate" class="transaction__info">
          <div class="transaction__info_title">Change rate</div>
          <div class="transaction__info_content flex">
            <div><span>$</span>{{ transaction.rate }}</div>
            <div><span>B</span>0.000234</div>
          </div>
        </div>
        <div v-if="transaction.payment" class="transaction__info">
          <div class="transaction__info_title">Payment type</div>
          <div class="transaction__info_content">
            <span>{{ transaction.payment_type }}</span>
            {{ transaction.payment }}
          </div>
        </div>
        <div class="transaction__info">
          <div class="transaction__info_title">Date</div>
          <div class="transaction__info_content">
            {{ format(new Date(transaction.created_at), 'dd MMMM yyyy') }}
            <!-- {{ $d(new Date(transaction.created_at)) }} -->
          </div>
        </div>
        <div v-if="transaction.status" class="transaction__info">
          <div class="transaction__info_title">Status</div>
          <div
            class="transaction__info_content"
            :class="{
              flex:
                transaction.status == 'On approve' ||
                transaction.status == 'Bank transer'
            }"
          >
            <template v-if="transaction.status == 'Send BTC'">
              Please send BTC to <span>{{ transaction.payment }}</span>
            </template>
            <template
              v-else-if="
                transaction.status == 'On approve' ||
                transaction.status == 'Bank transer'
              "
            >
              <div>
                <span class="color_2">{{ transaction.status }}</span>
              </div>
              <div><span class="color_3">48 hours max</span></div>
            </template>
            <template v-else-if="transaction.status === 'CON'">
              <span class="color_1">{{ transaction.status }}</span>
            </template>
          </div>
        </div>
        <div v-if="transaction.path" class="transaction__info">
          <div class="transaction__info_title"></div>
          <div class="transaction__info_content">
            <Button styles="size-2 style-1">Done</Button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from '@nuxtjs/composition-api'
import Button from '@/components/ui/Button.vue'
import { TransactionFragment } from '~/sdk/types'
import { format } from 'date-fns'
export default defineComponent<{
  transaction: TransactionFragment
  showSection: Boolean
}>({
  name: 'Transaction',
  components: {
    Button
  },
  props: ['transaction'],

  setup() {
    const showSection = false
    return {
      showSection,
      format
    }
  }
})
</script>

<style lang="scss" scoped>
.transaction {
  $self: &;

  margin-bottom: 16px;
  border: 1px solid #272c3b;
  transition: 0.25s border linear;
  border-radius: 3px;

  &:last-child {
    margin-bottom: 0px;
  }
  &.is-active {
    border: 1px solid #495271;
    #{ $self }__content {
      max-height: 1000px;
      transition: max-height 1s linear;
    }
    #{ $self }__top {
      &_arrow {
        svg {
          transform: rotate(-180deg);
        }
      }
    }
  }

  &__flex {
    display: flex;
    align-items: center;
  }
  &__top {
    cursor: pointer;
    background: #272c3b;
    padding: 10px 16px;

    display: flex;
    align-items: center;
    font-size: 0px;

    &_left {
      flex: 1;
      padding-right: 30px;
      display: flex;
      align-items: center;
      font-size: 0px;
    }
    &_right {
      display: flex;
      align-items: center;
      font-size: 0px;
      flex: none;
    }

    &_value {
      color: #ffffff;
      font-size: 36px;
      line-height: 36px;
      letter-spacing: 0px;
      margin-right: 25px;
      span {
        color: #0065ff;
        /* text-decoration: line-through; */
        margin-right: 2px;
      }
    }
    &_type {
      font-size: 18px;
      line-height: 18px;
      font-weight: bold;
      letter-spacing: 0.9px;
      color: #8591ad;
      text-transform: uppercase;
    }
    &_status {
      letter-spacing: 0px;
      color: #ffe200;
      font-weight: 500;
      font-size: 24px;
      line-height: 24px;
      margin-right: 40px;
      &.color {
        &_1 {
          color: #00ffb3;
        }
      }
    }
    &_date {
      font-weight: 500;
      font-size: 20px;
      line-height: 20px;
      letter-spacing: 0px;
      color: #7683ad;
      margin-right: 40px;
    }
    &_arrow {
      svg {
        fill: #fff;
        width: 16px;
        height: 16px;
        transition: 0.25s all linear;
      }
    }
  }
  &__content {
    max-height: 0;
    transition: max-height 0.5s linear;
    overflow: hidden;
    > div {
      padding: 30px 16px;
    }
  }
  &__info {
    margin-bottom: 20px;
    &:last-child {
      margin-bottom: 0px;
    }
    &_title {
      font-size: 24px;
      line-height: 30px;
      letter-spacing: 0px;
      margin-bottom: 5px;
      color: #9badd6;
    }
    &_content {
      color: #ffffff;
      font-weight: 500;
      font-size: 24px;
      line-height: 30px;
      &.flex {
        display: flex;
        align-items: center;
        > * {
          padding-right: 25px;
          &:last-child {
            padding-right: 0px;
          }
        }
      }
      span {
        color: #0065ff;
        &.color {
          &_1 {
            color: #00ffb3;
          }
          &_2 {
            color: #ffe200;
          }
          &_3 {
            color: #7683ad;
          }
        }
      }
    }
  }
}

@media (min-width: 1199.98px) {
  .history {
    $self: &;

    &__item {
      margin-bottom: 35px;
      &:last-child {
        margin-bottom: 0px;
      }
    }
    &__top {
      padding: 15px 30px;
    }

    &__content {
      > div {
        padding: 30px 50px;
      }
    }

    &__info {
      display: flex;
      align-items: center;
      &_title {
        flex: none;
        width: 200px;
        padding-right: 10px;
        margin-bottom: 0px;
      }
    }
  }
}
</style>
